%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name cyrus-sasl

%define w32_plugindir2 %{mingw32_libdir}/sasl2
%define w64_plugindir2 %{mingw64_libdir}/sasl2

Name:           mingw-cyrus-sasl
Version:        2.1.24
Release:        1%{?dist}
Summary:        The Cyrus SASL library

Group:          System Environment/Libraries
License:        BSD with advertising
URL:            http://asg.web.cmu.edu/sasl/sasl-library.html
# Source0 originally comes from ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/;
# make-no-dlcompatorsrp-tarball.sh removes the "dlcompat" subdirectory and builds a
# new tarball.
Source0:        cyrus-sasl-%{version}-nodlcompatorsrp.tar.gz
Source7:        sasl-mechlist.c
Source10:       make-no-dlcompatorsrp-tarball.sh
Patch0:         mingw-cyrus-sasl-build-fix-mingw64.patch
Patch1:         mingw-cyrus-sasl-getaddrinfo-x86_64.patch

Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-dlfcn
BuildRequires:  mingw64-dlfcn
BuildRequires:  autoconf, automake
%{?mingw_default_requires}
%{?mingw_debug_package}

%description
The %{name} package contains the Cyrus implementation of SASL.
SASL is the Simple Authentication and Security Layer, a method for
adding authentication support to connection-based protocols.


# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw32-%{mingw_pkg_name}
The %{name} package contains the Cyrus implementation of SASL.
SASL is the Simple Authentication and Security Layer, a method for
adding authentication support to connection-based protocols.

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw64-%{mingw_pkg_name}
The %{name} package contains the Cyrus implementation of SASL.
SASL is the Simple Authentication and Security Layer, a method for
adding authentication support to connection-based protocols.


%prep
%setup -q -n cyrus-sasl-%{version}
%patch0 -p1 -b .basetsd
%patch1 -p1 -b .getaddrinfox8664
autoreconf -vfi
chmod -x doc/*.html
chmod -x include/*.h

%build
CONFIGURE_ARGS="--enable-shared
             --disable-static
             --disable-java
             --disable-krb4
             --enable-gssapi${krb5_prefix:+=${krb5_prefix}}
             --with-gss_impl=mit
             --with-rc4
             --with-dblib=berkeley
             --without-saslauthd
             --without-pwcheck
             --without-authdaemond
             --with-devrandom=/dev/urandom
             --enable-anon
             --enable-cram
             --enable-digest
             --enable-ntlm
             --enable-plain
             --enable-login
             --disable-otp
             --without-sqlite"

%{mingw_set_suffix}
mkdir build_win32$suffix
pushd build_win32$suffix
%{mingw32_configure} "--with-plugindir=%{w32_plugindir2}" "--with-configdir=%{w32_plugindir2}:%{mingw32_sysconfdir}/sasl2" $CONFIGURE_ARGS
%mingw32_make %{?_smp_mflags} sasldir=%{w32_plugindir2}
make -C sample
pushd lib
../libtool --tag=CC --mode=link %{mingw32_cc} -o sasl2-shared-mechlist -I.. -I../../include $CFLAGS %{SOURCE7} $LDFLAGS ./libsasl2.la -lws2_32 -lwsock32
popd
popd

mkdir build_win64$suffix
pushd build_win64$suffix
 %{mingw64_configure} "--with-plugindir=%{w64_plugindir2}" "--with-configdir=%{w64_plugindir2}:%{mingw64_sysconfdir}/sasl2" $CONFIGURE_ARGS
%mingw64_make %{?_smp_mflags} sasldir=%{w64_plugindir2}
make -C sample
pushd lib
../libtool --tag=CC --mode=link %{mingw64_cc} -o sasl2-shared-mechlist -I.. -I../../include $CFLAGS %{SOURCE7} $LDFLAGS ./libsasl2.la -lws2_32 -lwsock32
popd
popd

%install
%{mingw_set_suffix}
test "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT

pushd build_win32$suffix
make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{w32_plugindir2}
make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{w32_plugindir2} -C plugins
install -m755 -d $RPM_BUILD_ROOT%{mingw32_bindir}
./libtool --tag=CC --mode=install \
install -m755 sample/client.exe $RPM_BUILD_ROOT%{mingw32_bindir}/sasl2-sample-client.exe
./libtool --tag=CC --mode=install \
install -m755 sample/server.exe $RPM_BUILD_ROOT%{mingw32_bindir}/sasl2-sample-server.exe

# Provide an easy way to query the list of available mechanisms. FIXME: tag=CC ??
cp  lib/sasl2-shared-mechlist.exe $RPM_BUILD_ROOT/%{mingw32_sbindir}/
popd

pushd build_win64$suffix
make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{w64_plugindir2}
make install DESTDIR=$RPM_BUILD_ROOT sasldir=%{w64_plugindir2} -C plugins
install -m755 -d $RPM_BUILD_ROOT%{mingw64_bindir}
./libtool --tag=CC --mode=install \
install -m755 sample/client.exe $RPM_BUILD_ROOT%{mingw64_bindir}/sasl2-sample-client.exe
./libtool --tag=CC --mode=install \
install -m755 sample/server.exe $RPM_BUILD_ROOT%{mingw64_bindir}/sasl2-sample-server.exe

# Provide an easy way to query the list of available mechanisms. FIXME: tag=CC ??
cp  lib/sasl2-shared-mechlist.exe $RPM_BUILD_ROOT/%{mingw64_sbindir}/
popd


# Remove unpackaged files from the buildroot.
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/sasl2/libotp.*
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/sasl2/libotp.*
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/sasl2/*.a
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/sasl2/*.a
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/sasl2/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/sasl2/*.la
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{mingw32_mandir}/cat8/saslauthd.8
rm -f $RPM_BUILD_ROOT%{mingw64_mandir}/cat8/saslauthd.8
rm -f $RPM_BUILD_ROOT%{mingw32_mandir}/man3/*
rm -f $RPM_BUILD_ROOT%{mingw64_mandir}/man3/*

%clean
test "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT


%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%doc saslauthd/LDAP_SASLAUTHD
%dir %{w32_plugindir2}/
%{mingw32_sbindir}/i686-w64-mingw32-pluginviewer.exe

#%files -n mingw32-%{mingw_pkg_name}-lib
%doc AUTHORS COPYING NEWS README doc/*.html
%{mingw32_bindir}/libsasl*.dll*
%dir %{w32_plugindir2}/
%{w32_plugindir2}/*anonymous*.dll*

#%files -n mingw32-%{mingw_pkg_name}-plain
%{w32_plugindir2}/*plain*.dll*
%{w32_plugindir2}/*login*.dll*
#%files -n mingw32-%{mingw_pkg_name}-md5
%{w32_plugindir2}/*crammd5*.dll*
%{w32_plugindir2}/*digestmd5*.dll*
#%files -n mingw32-%{mingw_pkg_name}-ntlm
%{w32_plugindir2}/*ntlm*.dll*
#%files -n mingw32-%{mingw_pkg_name}-gssapi
#%{w32_plugindir2}/*gssapi*.dll*

#%files -n mingw32-%{mingw_pkg_name}-devel
%doc doc/*.txt
%{mingw32_libdir}/libsasl*.dll.*
%{mingw32_bindir}/sasl2-sample-client.exe
%{mingw32_bindir}/sasl2-sample-server.exe
%{mingw32_includedir}/*
%{mingw32_sbindir}/sasl2-shared-mechlist.exe

%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%doc saslauthd/LDAP_SASLAUTHD
%dir %{w64_plugindir2}/
%{mingw64_sbindir}/x86_64-w64-mingw32-pluginviewer.exe

#%files -n mingw64-%{mingw_pkg_name}-lib
%doc AUTHORS COPYING NEWS README doc/*.html
%{mingw64_bindir}/libsasl*.dll*
%dir %{w64_plugindir2}/
%{w64_plugindir2}/*anonymous*.dll*

#%files -n mingw64-%{mingw_pkg_name}-plain
%{w64_plugindir2}/*plain*.dll*
%{w64_plugindir2}/*login*.dll*
#%files -n mingw64-%{mingw_pkg_name}-md5
%{w64_plugindir2}/*crammd5*.dll*
%{w64_plugindir2}/*digestmd5*.dll*
#%files -n mingw64-%{mingw_pkg_name}-ntlm
%{w64_plugindir2}/*ntlm*.dll*
#%files -n mingw64-%{mingw_pkg_name}-gssapi
#%{_plugindir2}/*gssapi*.dll*

#%files -n mingw64-%{mingw_pkg_name}-devel
%doc doc/*.txt
%{mingw64_libdir}/libsasl*.dll.*
%{mingw64_bindir}/sasl2-sample-client.exe
%{mingw64_bindir}/sasl2-sample-server.exe
%{mingw64_includedir}/*
%{mingw64_sbindir}/sasl2-shared-mechlist.exe

%changelog
* Thu Mar 24 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 2.1.24-1
- mingw32 build, based on branch:
  http://gitorious.org/cyrus-sasl/cyrus-sasl-elmarco/commits/mingw32
